<!doctype html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <title>VANILLA WC EXAMPLE</title>
        <link href="./assets/css/core/dist/dr-zp.css" rel="stylesheet" />
        <link href="./assets/css/sdk.css" rel="stylesheet" />
        <script type="module" src="https://my-datarobot-web.delta14.apps.datarobot.com/cdn/webcomponents/component-prod-bundle.js"></script>
        
        <script>
            document.addEventListener("DOMContentLoaded", function(event) {
                console.log('DOM fully loaded and parsed');
                var theLabel = document.querySelector('#label');

                fetch('https://my-datarobot-web.delta14.apps.datarobot.com/cdn/sdk-i18n-resources.json').then(function(response){
                    response.json().then(function(data) {
                        console.log(data);
                        console.log('response', data);
                        theLabel.i18n.addBundle(data);
                    });
                }).catch(function(error) {
                    console.log('Fetch Error:', error);
                });
    

                var modal = document.querySelector('#modal');
                modal.style.display = "";
                modal.isOpen = false;

                modal.addEventListener('modal-confirmation-clicked', e => {
                    console.info('dr-zp modal confirmation clicked');
                    theLabel.label = "confirmed";
                });

                modal.addEventListener('modal-cancel-clicked', e => {
                    console.info('dr-zp modal cancel clicked');
                    theLabel.label = "cancelled";
                });

                var buttons = document.querySelectorAll('dr-zp-button');

                buttons.forEach((button) => {
                    button.addEventListener('dr-zp-button-click', e => {
                        var source = e.detail.source;
                        console.log('dr-zp-button-click', source.outerHTML);
                        console.info('dr-zp-button-click on: ' + source.outerHTML);
                        modal.isOpen = true;
                    }); 
                });

                var grid = document.querySelector('#sampleGrid');
                grid.columns = [
                    {
                        caption: 'Selected',
                        field: '_selected',
                        key: '_selected', //must be unique
                        type: 'checkbox',
                        visible: true,
                        width: 40,
                    },
                    { 
                        caption: 'ID',
                        field: 'id',
                        key: 'id', //must be unique
                        type: 'text',
                        visible: true,
                        filterable: false,
                        sortable: true,
                        width: 70
                    },
                    {
                        caption: 'Name',
                        field: 'name',
                        key: 'name', //must be unique
                        type: 'link',
                        visible: true,
                        filterable: true,
                        sortable: true,
                        width: 70
                    }
                ];
                
                grid.data = [
                    {"id":"row_0","index":0,"date":1599777369980,"_selected":false,"enabled":true,"name":"Row 0","longText":"Some_very_long_non_breaking_text","paths":["114.173.43.1","114.173.43.2","114.173.43.3","114.173.43.4"],"hex":"#72ad2b","systems":["apple-logo","linux-logo","windows-logo"]},
                    {"id":"row_1","index":1,"date":1599777369980,"_selected":false,"enabled":false,"name":"Row 1","longText":"Some_very_long_non_breaking_text","paths":["202.130.187.1","202.130.187.2","202.130.187.3"],"hex":"#ca82bb","systems":["apple-logo","linux-logo","windows-logo"]},
                    {"id":"row_2","index":2,"date":1599777369980,"_selected":false,"enabled":false,"name":"Row 2","longText":"Some_very_long_non_breaking_text","paths":["197.79.119.1","197.79.119.2","197.79.119.3"],"hex":"#c54f77","systems":["apple-logo","linux-logo","windows-logo"]},
                    {"id":"row_3","index":3,"date":1599777369980,"_selected":false,"enabled":false,"name":"Row 3","longText":"Some_very_long_non_breaking_text","paths":["19.69.147.1","19.69.147.2","19.69.147.3"],"hex":"#134593","systems":["apple-logo","linux-logo","windows-logo"]},
                    {"id":"row_4","index":4,"date":1599777369980,"_selected":false,"enabled":false,"name":"Row 4","longText":"Some_very_long_non_breaking_text","paths":["4.110.227.1","4.110.227.2","4.110.227.3"],"hex":"#046ee3","systems":["apple-logo","linux-logo","windows-logo"]}
                ];
    
                var dropdown = document.querySelector('#dropdown');
                dropdown.items = ['Hello', 'Goodbye', 'See Ya!'];
                dropdown.selecteditem = dropdown.items[0];

                dropdown.addEventListener('dropdown-change', e => {
                    console.info('dropdown-change', e);
                    modal.modalTitle = e.detail.selected;
                });

                gauge = document.querySelector('#gauge');

                this.interval = setInterval(() => {
                    var rand = Math.round(Math.random() * 100);

                    var chartData = [
                        ["Label", "Value"],
                        ["CPU", rand]
                    ];

                    var data = google.visualization.arrayToDataTable(chartData, false); // 'false' means that the first row contains labels, not data.
                    console.info('randomize', rand, chartData);
                    gauge.data = chartData;
                    gauge.redraw();
                }, 5000);

                document.addEventListener('keydown', (e) => {
                    const code = e.code;
                    console.info('globalKeyDown', code);         

                    if(code === "Escape") { 
                        document.dispatchEvent(new CustomEvent("escape-action", {
                            detail: {}
                        }));
                    }
                    else if(code.indexOf("Enter") > -1) {
                        document.dispatchEvent(new CustomEvent("enter-action", {
                            detail: {}
                        }));
                    }
                });
            });   
        </script>

    </head>

    <body style="background-color: #222; padding: 20px; color: white">
        <h2 style="color: var(--main-fg-color); margin-bottom: 20px">VANILLA EPS WC SDK EXAMPLE</h2>

        <div style="width: 200px; margin-bottom: 20px;">
            <dr-zp-dropdown id="dropdown" full-width></dr-zp-dropdown>
        </div>

        <div style="margin-bottom: 20px;">
            <dr-zp-button type="primary" size="small" label="Open Modal"></dr-zp-button>
        </div>

        <div style="margin-bottom: 20px;">
            <dr-zp-label id="label" label=""></dr-zp-label>
        </div>

        <div style="width: 200px; margin-bottom: 20px;">
            <google-chart id="gauge"
                type="gauge"
                data='[
                        ["Label", "Value"],
                        ["CPU", 20]
                    ]'
                options='{"width": 800,
                            "height": 200,
                            "redFrom": 90,
                            "redTo": 100,
                            "yellowFrom":75,
                            "yellowTo": 90,
                            "minorTicks": 5}'>
            </google-chart>
        </div>    
        
        
        <div style="position: relative; width: 100%; height: 300px; margin-bottom: 20px;">
            <dr-zp-grid 
                id="sampleGrid"
                grid-title="Sample Grid"
                primary-key="id">
            </dr-zp-grid>
        </div>

        <dr-zp-modal id="modal" style="display: none"
            is-open="[[false]]"
            modal-title="Confirmation"
            size="md"
            show-footer="true"
            confirmation-label="Submit"
            cancel-label="Cancel">
            <div slot="slot-content">
                You clicked ?
            </div>
        </dr-zp-modal>

    </body>
</html>